package org.netkernel.mod.architecture.bits.channel;

import java.util.ArrayList;
import java.util.List;

import org.netkernel.layer0.util.TupleList;

public class Column
{
	private List<SpaceGroup> mSpaceGroups=new ArrayList<SpaceGroup>();
	private int mDepth;
	
	public Column(int aDepth, List<SpaceGroup> aSpaceGroups)
	{	mSpaceGroups=aSpaceGroups;
		mDepth=aDepth;
	}
	
	public int getDepth()
	{	return mDepth;
	}
	
	public List<SpaceGroup> getSpaceGroups()
	{	return mSpaceGroups;
	}
	
	public float getBadness()
	{
		float badness=0;
		int s=mSpaceGroups.size();
		if (s>2)
		{
			for (int i=0; i<s; i++)
			{	SpaceGroup sg1=mSpaceGroups.get(i);
				if (sg1.hasSpace())
				{	for (int j=i+1; j<s; j++)
					{	SpaceGroup sg2=mSpaceGroups.get(j);
						if (sg2.getSpace()==sg1.getSpace())
						{
							for (int k=i+1; k<j; k++)
							{	SpaceGroup sg3=mSpaceGroups.get(k);
								if (sg3.getSpace()==null)
								{	if (sg3.hasChannelThrough())
									{	badness+=0.25f;
									}
									else
									{	badness+=0.05f;
									}
								}
								else
								{	badness+=1.0f;
								}
							}
							break;
						}
					}
				}
			}
		}
		return badness;
	}
	
	public List<Shuffle> getShuffles(Shuffle aShuffle)
	{
		ArrayList<Shuffle> result=new ArrayList<Shuffle>();
		

		int s=mSpaceGroups.size();
		if (s>2)
		{	TupleList candidatesList=new TupleList(3, 4);
			for (int i=0; i<s; i++)
			{	SpaceGroup sg1=mSpaceGroups.get(i);
				if (sg1.hasSpace())
				{	for (int j=i+1; j<s; j++)
					{	SpaceGroup sg2=mSpaceGroups.get(j);
						if (sg2.getSpace()==sg1.getSpace())
						{	float badness=0.0f;
							for (int k=i+1; k<j; k++)
							{	SpaceGroup sg3=mSpaceGroups.get(k);
								if (sg3.getSpace()==null)
								{	badness+=0.25f;
								}
								else
								{	badness+=1.0f;
								}
							}
							candidatesList.put(badness,sg1,sg2);
							break;
						}
					}
				}
			}
			float baddest=(Float)candidatesList.getValue(0, 0);
			int baddestIndex1=0;
			int baddestIndex2=-1;
			//System.out.println("candidate: "+candidatesList.getValue(0, 0)+" "+candidatesList.getValue(0, 1)+" "+candidatesList.getValue(0, 2));
			for (int i=1; i<candidatesList.size(); i++)
			{	
				//System.out.println("candidate: "+candidatesList.getValue(i, 0)+" "+candidatesList.getValue(i, 1)+" "+candidatesList.getValue(i, 2));
				float v=(Float)candidatesList.getValue(i, 0);
				if (baddest<v)
				{	baddest=v;
					baddestIndex1=i;
					baddestIndex2=-1;
				}
				else if (baddest==v)
				{	baddestIndex2=i;
				}
			}
			//System.out.println("candidateList="+candidatesList.size()+" "+baddestIndex);
			
			{
				SpaceGroup g1=(SpaceGroup)candidatesList.getValue(baddestIndex1, 1);
				SpaceGroup g2=(SpaceGroup)candidatesList.getValue(baddestIndex1, 2);
				//put B before A
				result.add(ChannelViewAccessor.shuffleChannels(aShuffle, g2.getStart(), g2.getEnd(), g1.getStart()));
				//put A after B
				result.add(ChannelViewAccessor.shuffleChannels(aShuffle, g1.getStart(), g1.getEnd(), g2.getEnd()));
				
				//put B after A
				result.add(ChannelViewAccessor.shuffleChannels(aShuffle, g2.getStart(), g2.getEnd(), g1.getEnd()));
				//put A before B
				result.add(ChannelViewAccessor.shuffleChannels(aShuffle, g1.getStart(), g1.getEnd(), g2.getStart()));
				
			}
		}
		return result;
	}
	
	public Column getWithGapsMerged()
	{
		List<SpaceGroup> result=new ArrayList<SpaceGroup>();
		SpaceGroup lastGroup=null;
		for (SpaceGroup sg : mSpaceGroups)
		{
			if (sg.hasSpace())
			{	
				if (lastGroup!=null && lastGroup.getSpace()==sg.getSpace())
				{	lastGroup = new SpaceGroup(lastGroup.getSpace(), lastGroup.getStart());
					lastGroup.setEnd(sg.getEnd());
				}
				else if (lastGroup!=null && lastGroup.getSpace()!=sg.getSpace())
				{	result.add(lastGroup);
					lastGroup=sg;
				}
				else
				{	lastGroup=sg;
				}
			}
		}
		if (lastGroup!=null)
		{	result.add(lastGroup);
		}
		
		return new Column(mDepth, result);
	}
	
	
	
	
}
