package org.netkernel.mod.architecture.bits.staticstructure;

import java.awt.geom.Dimension2D;

import org.netkernel.ext.system.representation.IRepDeployedModules;
import org.netkernel.ext.system.representation.impl.SpaceGraph;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.impl.HDSBuilder;

public interface IStaticStructureDiagramDecorator
{
	void initialise(IHDSNode aParams, IRepDeployedModules aModules, SpaceGraph aSpaceGraph, IHDSNode aSettings, INKFRequestContext aContext) throws Exception;
	
	boolean isLibrarySpace(String aSpaceHash);
	boolean showLibraries();
	boolean mergeLibraries();
	boolean showRoot(String aSpaceHash);
	boolean showEdge(String aFromSpaceHash, String aToSpaceHash, int aDepth);
	boolean showModules();
	boolean shade();
	
	void decorateEdge(HDSBuilder aBuilder, GraphEdge aEdge, String aId);
	void decorateSpace(HDSBuilder aBuilder, GraphNode aSpace, String aId);
	void decorateSVG(HDSBuilder aBuilder, String aId);
}
