<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  xmlns:nk="http://1060.org">
    <xsl:output method="xml"/>
	 <xsl:param name="hash" nk:class="java.lang.String"/>
	 
	<xsl:template match="/">

		<div xmlns:xrl='http://netkernel.org/xrl' style="height: 100%;" id="fill">
			<style type="text/css" media="screen">
			#editor {
		        position: relative;
    			height: 300px;
		    }
		    #dir {
		    	overflow: scroll;
		    }
		    .nrm {
		    	padding-right: 0px;
		    }
		    .nlm {
		    	padding-left: 0px;
		    }
		    .excluded { color: #CCC; }
		    #buttons button { padding-top: 4px; padding-bottom: 4px; }
		    #status { padding: 4px; }
		    .icon-folder-close-alt, .icon-file-alt { padding-right: 1px; }
			</style>
			
			<xrl:include>
				<xrl:identifier>active:aeMenu</xrl:identifier>
				<xrl:argument name="hash"><xsl:value-of select="$hash"/></xrl:argument>
				<xrl:argument name="tool"><literal type="string">NetKernel IDE</literal></xrl:argument>
			</xrl:include>
			
			<!-- this stuff is dynamically inserted at end of explorer navbar/menu -->
			<!--
			<div id="extraMenuStuff">
				<td><span class='separator'> / </span></td>
				<td id="filename"><span style="padding-left: 3px;"/></td>
				<td id="readonly"><span style="margin-left: 3px; color: white; font-weight: bold" class="label label-danger">Readonly</span></td>
			</div>
			-->
			
			<div class="row">
				<div class="col-sm-3 nrm">
					<xsl:call-template name="dirTree"/>
				</div>
				<div class="col-sm-9 nlm">
					<div>
						<pre id="editor"></pre>
					</div>
					<div id="buttons">
						<button id="saveButton" type="button" class="btn btn-primary">save</button>
						<xsl:text> </xsl:text>
						<button id="deleteButton" type="button" class="btn btn-danger"><i class="fa fa-trash" aria-hidden="true"><xsl:text> </xsl:text></i>delete</button>
						<xsl:text> </xsl:text>
						<button id="newButton" type="button" class="btn btn-success">new file...</button>
						<span id="status"/>
					</div>
				</div>
			</div>
			
			<div class="modal fade" tabindex="-1" role="dialog" id="newFileDialog">
				<div class="modal-dialog" role="document">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal" aria-label="cancel">
								<span aria-hidden="true">&#x00D7;</span>
							</button>
							<h4 class="modal-title">New File</h4>
						</div>
						<div class="modal-body">
							<form class="form-horizontal">
								<div class="form-group">
									<label for="directory" class="col-sm-2 control-label">Directory</label>
									<div class="col-sm-10">
										<input type="text" class="form-control" id="directory" placeholder="directory" />
									</div>
								</div>
								<div class="form-group">
									<label for="filenameField" class="col-sm-2 control-label">Filename</label>
									<div class="col-sm-10">
										<input type="text" class="form-control" id="filenameField" placeholder="Filename" />
									</div>
								</div>
							</form>
						</div>
						<div class="modal-footer">
							<button type="button" class="btn btn-default" data-dismiss="modal">cancel</button>
							<button type="button" class="btn btn-success" id="newSubmit">New</button>
						</div>
					</div><!-- /.modal-content -->
				</div><!-- /.modal-dialog -->
			</div><!-- /.modal -->
			
			<div class="modal fade" tabindex="-1" role="dialog" id="deleteFileDialog">
				<div class="modal-dialog" role="document">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal" aria-label="cancel">
								<span aria-hidden="true">&#x00D7;</span>
							</button>
							<h4 class="modal-title">Delete File</h4>
						</div>
						<div class="modal-body">
							<p>Do you really want to delete file <b>"<span id="toDelete"/>"</b>?</p>
						</div>
						<div class="modal-footer">
							<button type="button" class="btn btn-default" data-dismiss="modal">cancel</button>
							<button type="button" class="btn btn-success" id="deleteSubmit">delete</button>
						</div>
					</div><!-- /.modal-content -->
				</div><!-- /.modal-dialog -->
			</div><!-- /.modal -->
			
			
			<script src="https://cdnjs.cloudflare.com/ajax/libs/ace/1.2.3/ace.js" type="text/javascript" charset="utf-8"></script>
			<script src="https://cdnjs.cloudflare.com/ajax/libs/ace/1.2.3/ext-modelist.js" type="text/javascript" charset="utf-8"></script>
			<script src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.2.0/require.js" type="text/javascript" charset="utf-8"></script>
			<script type="text/javascript"><xsl:comment>
				var editor;
				var writable=<xsl:value-of select="/dir/@writable"/>;
				var selectedFile='<xsl:value-of select='/*/@initialFile'/>';
				var modified=false;
				var viewedFile="";
				//var editor;
				
				function updateSaveState()
				{	$("#saveButton").prop('disabled', !modified);
					$("#status").text("");
				}
				
				function selectFile(id) {
					if (modified)
					{	if (!confirm("Unsaved changes - are you sure you want to leave file?"))
						{	return;
						}
					}
					
					selectedFile=id;
					//alert(id);
					$.post("<xsl:value-of select='$hash'/>",{'loadResource':id},function(data,status,xhr) {
						
						//determine syntax mode using modelist or our own overrides
						var mode=undefined;
						var s="";
						var i=id.lastIndexOf(".");
						if (i>=0)
						{	s=id.substring(i+1);
						}
						if (s=="xsl" || s=="idoc" || s=="dpml")
						{	mode="ace/mode/xml";
						}
						else if (s=="gy")
						{	mode="ace/mode/groovy";
						}
						else if (s=="bsh")
						{	mode="ace/mode/java";
						}
						if (mode==undefined)
						{
							var modelist = ace.require("ace/ext/modelist")
							var mode = modelist.getModeForPath(id).mode;
						}
						editor.session.setMode(mode);
						
						
						editor.setValue(data);
						editor.gotoLine(1,0,false);
						editor.scrollToLine(0);

						if (writable)
						{
							editor.on("change",function() {
								modified=true;
								updateSaveState();
							});
						}
						else
						{	editor.setReadOnly(true);
						}
						
						$("#filename").text(id);
						modified=false;
						viewedFile=id;
						updateSaveState();
						
						},"text"
						
					);
				}
				
				function saveFile()
				{	var fileContents=editor.getValue();
					$.post("<xsl:value-of select='$hash'/>",{'saveResource':viewedFile, 'contents':fileContents},function(data) {
						modified=false;
						updateSaveState();
					});
					
				}
				
				function deleteFile()
				{	var path="/"+selectedFile;
					$('#toDelete').text(path);
					$('#deleteFileDialog').modal({});
				}
				
				function deleteSubmit()
				{
					$('#deleteFileDialog').modal('hide');
					var path="/"+selectedFile;
					$.post("<xsl:value-of select='$hash'/>",{'deleteResource':path},function(data) {
						if (data.error)
						{	$("#status").text(data.error);
						}
						else
						{
							window.location.href="/tools/ae/view/modulePhysicalResources/<xsl:value-of select='$hash'/>";
						}
					},'json');
				}
				
				function newFile()
				{	
					//console.log(selectedFile);
					var path="/"+selectedFile;
					i=path.lastIndexOf('/');
					path=path.substring(0,i+1);
					
					$('#directory').val(path);
					$('#filenameField').val('');
					$('#newFileDialog').modal({});
				}
				
				function newFileSubmit()
				{
					$('#newFileDialog').modal('hide');
					var path=$('#directory').val()+$('#filenameField').val();
					$.post("<xsl:value-of select='$hash'/>",{'newResource':path},function(data) {
						if (data.error)
						{	$("#status").text(data.error);
						}
						else
						{
							window.location.href="/tools/ae/view/modulePhysicalResources/<xsl:value-of select='$hash'/>"+path;
						}
					},'json');
				}
				
				function resize()
				{	height=$( window ).height(); //$("#fill").height();
					var heightOffset=250;
					var buttonHeight=$("#buttons").height();
					var editorHeight=height-heightOffset;
					if (writable) editorHeight-=buttonHeight;
  					$('#editor').css('height',editorHeight);
  					$('#dir').css('height',height-heightOffset);
				}
    		
    			$(window).resize(function()
    			{	resize();
				});
				
				
				$(document).ready(function() {
					resize();
					
					$( document ).ajaxError(function( event, jqxhr, settings, thrownError ) {
						console.log(jqxhr);
						console.log(thrownError);
						var msg=jqxhr.statusText+": "+jqxhr.responseText;
						$("#status").text(msg);
					});
					
					var explorerBar=$(".explore-navbar").find("span:last");
					explorerBar.attr("id","filename");
					//$("#filename").text("hello");
					
					if (writable)
					{	$("#saveButton").click( function() {
							saveFile();
						});
						$("#newButton").click( function() {
							newFile();
						});
						$("#newSubmit").click( function() {
							newFileSubmit();
						});
						$("#deleteButton").click( function() {
							deleteFile();
						});
						$("#deleteSubmit").click( function() {
							deleteSubmit();
						});
					}
					else
					{	$(".explore-navbar").append("&lt;span class='label label-danger' style='font-size: 9px; margin-left: 3px; color: white; font-weight: bold'&gt;Readonly&lt;/span&gt;")
					}
					
					
					selectFile("<xsl:value-of select='/*/@initialFile'/>");
					//selectFile("module.xml");

					editor = ace.edit("editor");
    				editor.setTheme("ace/theme/chrome");
    				editor.getSession().setMode("ace/mode/javascript");
					//editor.resize();
					
					initLinksRaw( ".el-module", "gMenuModule");
					initLinksRaw( ".el-space", "gMenuSpace");
					initLinksRaw( ".el-physical", "gMenuPhysical");
					initLinksRaw( ".el-ep", "gMenuEp");
					initLinksRaw( ".el-proto", "gMenuProto");
					initLinksRaw( ".el-rep", "gMenuRep");
					
					window.addEventListener("beforeunload", function (e) {
        				if (!modified) {
				            return undefined;
				        }
				        var confirmationMessage = 'It looks like you have been editing something. '
				                                + 'If you leave before saving, your changes will be lost.';				
				        (e || window.event).returnValue = confirmationMessage; //Gecko + IE
				        return confirmationMessage; //Gecko + Webkit, Safari, Chrome etc.
				    });
					
				});
			</xsl:comment></script>
		</div>
	</xsl:template>
	
	<xsl:template name="dirTree">
		<div style="width:100%;" id="dir" >
			<xsl:for-each select="/dir">
				<xsl:call-template name="dir">
					<xsl:with-param name="depth">0</xsl:with-param>
					<xsl:with-param name="dmap"></xsl:with-param>
				</xsl:call-template>
			</xsl:for-each>
		</div>
	</xsl:template>
	
	<xsl:template name="dir">
		<xsl:param name="dmap" />
		<xsl:param name="depth" />
		<div class="uitw"><span class="uit">
			<xsl:call-template name="tree">
				<xsl:with-param name="dmap"><xsl:value-of select="$dmap"/></xsl:with-param>
				<xsl:with-param name="children">
					<xsl:if test="count(dir)+count(res)"><xsl:value-of select="@order"/></xsl:if>
				</xsl:with-param>
			</xsl:call-template>
			</span>
			<span class="fa fa-folder-open-o"> </span> <xsl:value-of select="@name"/>
		</div>
		
		<xsl:for-each select="*">
			<xsl:variable name="c">
				<xsl:choose>
					<xsl:when test="position()=last()">1</xsl:when>
					<xsl:otherwise>0</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:choose>
				<xsl:when test="name()='dir'">						
					<xsl:call-template name="dir">
						<xsl:with-param name="depth"><xsl:value-of select="$depth + 1"/></xsl:with-param>
						<xsl:with-param name="dmap"><xsl:value-of select="$dmap"/><xsl:value-of select="$c"/></xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="name()='res'">
					<xsl:call-template name="res">
						<xsl:with-param name="depth"><xsl:value-of select="$depth + 1"/></xsl:with-param>
						<xsl:with-param name="dmap"><xsl:value-of select="$dmap"/><xsl:value-of select="$c"/></xsl:with-param>
					</xsl:call-template>
				</xsl:when>
			</xsl:choose>
		</xsl:for-each>		
		
	</xsl:template>
	
	<xsl:template name="res">
		<xsl:param name="dmap" />
		<xsl:param name="depth" />
		<div class="uitw"><span class="uit">
			<xsl:call-template name="tree">
				<xsl:with-param name="dmap"><xsl:value-of select="$dmap"/></xsl:with-param>
				<xsl:with-param name="children">
					<xsl:if test="count(dir)+count(res)"><xsl:value-of select="@order"/></xsl:if>
				</xsl:with-param>
			</xsl:call-template>
			</span>
			<xsl:choose>
				<xsl:when test="excluded='true'">
					<span class="excluded">
						<span class="fa fa-file-o"> </span><xsl:value-of select="@name"/>
					</span>
				</xsl:when>
				<xsl:otherwise>
					<a onclick="selectFile('{substring(@id,6)}')" href="#">
						<span class="fa fa-file-text-o"> </span><xsl:value-of select="@name"/>
					</a>
				</xsl:otherwise>
			</xsl:choose>
		</div>
		
	</xsl:template>
	
	<xsl:template name="tree">
		<xsl:param name="dmap" />
		<xsl:param name="children" />
		<xsl:if test="$dmap != ''">
			<xsl:variable name="letter" select="substring($dmap, 1, 1)" />
			<xsl:call-template name="tree-el">
				<xsl:with-param name="el"><xsl:value-of select="$letter" /></xsl:with-param>
				<xsl:with-param name="last">
					<xsl:choose>
						<xsl:when test="string-length($dmap)=1 and string-length($children)"><xsl:value-of select="$children" /></xsl:when>
						<xsl:when test="string-length($dmap)=1">0</xsl:when>
						<xsl:otherwise></xsl:otherwise>
					</xsl:choose>
				</xsl:with-param>
			
			</xsl:call-template>
			<xsl:call-template name="tree">
				<xsl:with-param name="dmap" select="substring-after($dmap, $letter)" />
				<xsl:with-param name="children" select="$children" />
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="tree-el">
		<xsl:param name="el"/>
		<xsl:param name="last"/>
		<xsl:choose>
			<xsl:when test="string-length($last)=0">
				<xsl:choose>
					<xsl:when test="$el=0"><span class="uit1" ><xsl:text> </xsl:text></span></xsl:when>
					<xsl:otherwise><span class="uit0"><xsl:text> </xsl:text></span></xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<span>
					<xsl:choose>
						<xsl:when test="$el=0"><xsl:attribute name="class">uit2</xsl:attribute></xsl:when>
						<xsl:otherwise><xsl:attribute name="class">uit3</xsl:attribute></xsl:otherwise>
					</xsl:choose>
					<xsl:text> </xsl:text>
				</span>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>