<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xalan="http://xml.apache.org/xalan" xmlns:nk="http://1060.org">
    <xsl:output method="xml"/>
	
	<xsl:template match="/">
		<div>
			<style type="text/css"><![CDATA[
				.cw { width: 6em; text-align: center; }
			]]></style>
			<form method="post">
				<table class="table table-striped">
					<tr class="vis-title">
						<th/>
						<th colspan="7" style="text-align: center">Logging Levels Enabled</th>
					</tr>
					<tr class="vis-title">
						<th>Log Name</th>
						<th class="cw">Severe</th>
						<th class="cw">Warning</th>
						<th class="cw">Info</th>
						<th class="cw">Fine</th>
						<th class="cw">Finer</th>
						<th class="cw">Debug</th>
						<th class="cw">Cache</th>
					</tr>
					<xsl:for-each select="/logs/log">
						<xsl:variable name="class">
							<xsl:choose>
								<xsl:when test="position() mod 2 = 0">
									<xsl:text>evenrow</xsl:text>
								</xsl:when>
								<xsl:otherwise>
									<xsl:text>oddrow</xsl:text>
								</xsl:otherwise>  
							</xsl:choose>
						</xsl:variable>
						<tr class="{$class}">
							<td>
								<xsl:value-of select="name"/>
							</td>
							<xsl:for-each select="levels/*">
								<td class="cw">
									<input type="checkbox" name="{../../id}-{name()}">
										<xsl:if test="text()='true'"><xsl:attribute name="checked"></xsl:attribute>
										</xsl:if>
									</input>
								</td>
							</xsl:for-each>
						</tr>
					</xsl:for-each>
				</table>
				<input class="btn btn-primary" type="submit" value="Save changes" />
			</form>
		</div>
	</xsl:template>
	
</xsl:stylesheet>