<?xml version="1.0" encoding="UTF-8" ?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xrl="http://netkernel.org/xrl">
	<xsl:output method="xml" />
	<xsl:param name="param" />
	<xsl:param name="config" />
	<xsl:param name="history" />

	<xsl:variable name="explorer">
		/tools/explore/
	</xsl:variable>

	<xsl:include href="res:/nkse/style/xsl/format_resolution.xsl" />

	<xsl:template match="/">
		<div>
			<style>
			.pseudo-control { border-radius: 4px; border: solid 1px #CCC; margin: 2px 0; padding: 2px 2px;}
			label { text-align: right; }
			</style>

			<xsl:call-template name="js" />
			<div class="container">
				<xsl:call-template name="form" />
				<xsl:call-template name="results" />
			</div>
			
		</div>
	</xsl:template>


	<xsl:template name="js">
		<script type="text/javascript">
			<xsl:comment>
	  <![CDATA[
	  
	$(function() {
	
	
	
		$('#requestType a').click(function (e) {
			//console.log(e);
			
	  		e.preventDefault()
	  		$(this).tab('show');
	  		//document.form1.mode.value="";
	  		
		})
		
		$('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
  			var mode=e.target.getAttribute("href").substring(1);
  			document.form1.mode.value=mode;
		})
		
		
		
		
	});
	
	function doRequest(name)
	{	document.form1.action1.value=name;
 		document.form1.submit(); 	
	}
	
	function spaceExplorerSpace()
	{	hash=$("#spaceSelect").val();
		window.location='/tools/ae/view/spaceDetails/'+hash;
	}
	function spaceExplorerModule()
	{	hash=$("#spaceSelect").val();
		window.location='/tools/ae/view/moduleDetails/'+hash.split("/")[0];
	}
	
	function prefill()
	{	$("#declreq").val("<request>\n    <verb>SOURCE</verb>\n    <identifier></identifier>\n    <argument name=\"\"></argument>\n</request>");
	}
	
	function doInline()
	{	
	  		//document.form1.action="/tools/requesttrace";
	  		document.form1.action1.value='display';
	  		//document.form1.submit();
	  		//Use AJAX instead...
			var form = $('form');
			var formAction = "/tools/requesttrace";
			var result = formAction + '?' + form.serialize();
			
			$("#results").remove();
			$("#execdirect").attr("href", result);
			$("#repdisplay").show();
			$("#repiframe").attr("src", result);
	
	  }
	
	]]>
	
	<xsl:if test="$param/config/params/mode='declarative'">
		$(function() {
			//hack - how to make tab initialise on right content?
			//$("#simple").css("display","none");
			//$("#declarative").css("display","block");
			document.form1.mode.value="declarative";
			//$("#declarative-tab").find('a').tab('show');
			setTimeout(function() {
				$("#dta").tab('show');
			}, 100 );
		});
	</xsl:if>
	
	<xsl:if test="not(string-length($param/config/params/declreq)&gt;0)">
		$(function() { prefill(); });
	</xsl:if>
	
	
			</xsl:comment>
		</script>

	</xsl:template>

	<xsl:template name="form">

		<xrl:include>
			<xrl:identifier>active:controlPanelInfoBox</xrl:identifier>
			<xrl:argument name="content">
				<div>
					<p>
						The Request Resolution Trace tool will create and inject a resource request
						into a specified space with a specified resource identifier and request verb.
					</p>
					<p>
						To configure a request trace:
					</p>
					<ul>
						<li>Select a module (This will populated the Space drop down list)</li>
						<li>Select a space.</li>
						<li>Decide if you want to specify you request as a simple identifier and VERB or
						as a <a href="/book/view/book:guide:standardmodule/doc:logicalreference:module:standard:logical:declarative:request:syntax">declarative request</a>.</li>
						<li>Enter the request details</li>
					</ul>
					<p>
						To issue the request trace click on the button labeled:
					</p>
					<ul>
						<li>"Resolve" to determine if the request resolves to an endpoint.</li>
						<li>"Request Response" will issue the request for execution by the endpoint and display the response metadata.</li>
						<li>"Request Representation" will issue request and return representation to browser inside an iFrame.</li>
						<li>"Request Raw" will issue request and return representation into browser.</li>
						<li>"Visualize" will capture the request in the visualizer for more detailed inspection.</li>
					</ul>
				</div>
			</xrl:argument>
		</xrl:include>

		<xsl:variable name="module">
			<xsl:choose>
				<xsl:when test="$param/config/params/module">
					<xsl:value-of select="$param/config/params/module" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:for-each select="/modules/module">
						<xsl:sort select="id" />
						<xsl:if test="position()=1">
							<xsl:value-of select="hash" />
						</xsl:if>
					</xsl:for-each>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<div class="row">
			<form class="form-horizontal" name="form1">

				<div class="form-group">
					<label for="history" class="col-sm-2 control-label">History</label>
					<div class="col-sm-10">
						<select name="history" class="form-control" onchange="doRequest('')">
							<option value="">select previous request...</option>
							<xsl:choose>
								
								<xsl:when test="$history/history/trace">
									<xsl:for-each select="$history/history/trace">
										<option value="{position()}"><xsl:value-of select="display"/></option>
									</xsl:for-each>	
								
								</xsl:when>
							</xsl:choose>
						</select>
					</div>
				</div>

				<div class="form-group">
					<label for="module" class="col-sm-2 control-label">Module</label>
					<div class="col-sm-9">
						<select name="module" class="form-control" onchange="doRequest('')">
							<xsl:for-each select="/modules/module">
								<xsl:sort select="id" />
								<option>
									<xsl:attribute name="value">
                      <xsl:value-of select="hash" />
                    </xsl:attribute>
									<xsl:if test="$param/config/params/module=hash">
										<xsl:attribute name="selected">true</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="id" />
									-
									<xsl:value-of select="version" />
								</option>
							</xsl:for-each>
						</select>
					</div>
					<div class="col-sm-1 hidden-xs">
						<a class="btn btn-default" href="javascript:spaceExplorerModule();" title="view module"><span class="fa fa-external-link"> </span></a>
					</div>
				</div>

				<div class="form-group">
					<label for="space" class="col-sm-2 control-label">Space</label>
					<div class="col-sm-9">
						<select id="spaceSelect" class="form-control" name="space">
							<xsl:for-each select="/modules/module[hash=$module]/spaces/space">
								<xsl:call-template name="space-option" />
							</xsl:for-each>
						</select>
					</div>
					<div class="col-sm-1 hidden-xs">
						
						<a class="btn btn-default" href="javascript:spaceExplorerSpace();" title="view space"><span class="fa fa-external-link"> </span></a>
					</div>
				</div>

				<div class="form-group">
					<input type="hidden" name="mode"/>
					<label for="identifier" class="col-sm-2 control-label">Mode</label>
					<div class="col-sm-10">
						<ul class="nav nav-pills" role="tablist" id="requestType">
							<li role="presentation" class="active">
								<a href="#simple" role="tab" data-toggle="tab">Simple</a>
							</li>
							<li role="presentation" id="declarative-tab">
								<a href="#declarative" id="dta" role="tab" data-toggle="tab">Declarative</a>
							</li>
						</ul>
					</div>
				</div>

				<div class="tab-content">
					<div role="tabpanel" class="tab-pane active" id="simple">
						<div class="form-group">
							<label for="identifier" class="col-sm-2 control-label">Identifier</label>
							<div class="col-sm-10">
								<input type="text" id="identifier" name="identifier" value="{$param/config/params/identifier}" class="form-control" />
							</div>
						</div>
						<div class="form-group">
							<label for="verb" class="col-sm-2 control-label">Verb</label>
							<div class="col-sm-4">
								<select name="verb" class="form-control">
									<option value="1">
										<xsl:if test="$param/config/params/verb='1'">
											<xsl:attribute name="selected">true</xsl:attribute>
										</xsl:if>
										SOURCE
									</option>
									<option value="2">
										<xsl:if test="$param/config/params/verb='2'">
											<xsl:attribute name="selected">true</xsl:attribute>
										</xsl:if>
										SINK
									</option>
									<option value="4">
										<xsl:if test="$param/config/params/verb='4'">
											<xsl:attribute name="selected">true</xsl:attribute>
										</xsl:if>
										EXISTS
									</option>
									<option value="8">
										<xsl:if test="$param/config/params/verb='8'">
											<xsl:attribute name="selected">true</xsl:attribute>
										</xsl:if>
										DELETE
									</option>
									<option value="16">
										<xsl:if test="$param/config/params/verb='16'">
											<xsl:attribute name="selected">true</xsl:attribute>
										</xsl:if>
										NEW
									</option>
									<option value="256">
										<xsl:if test="$param/config/params/verb='256'">
											<xsl:attribute name="selected">true</xsl:attribute>
										</xsl:if>
										META
									</option>
								</select>
							</div>
						</div>


					</div>
					<div role="tabpanel" class="tab-pane" id="declarative">
						<div class="form-group">
							<label for="declreq" class="col-sm-2 control-label">Request XML</label>
							<div class="col-sm-9">
								<textarea id="declreq" rows="5" type="text" name="declreq" class="form-control">
									<xsl:value-of select="$param/config/params/declreq" />
								</textarea>
							</div>
							<div class="col-sm-1">
								<a class="btn btn-default" href="javascript:prefill()" title="Reload template request">
									<span class="fa fa-refresh"> </span>
								</a>
							</div>
						</div>
					</div>
				</div> <!-- end of tab content -->
				<br />
				<div class="form-group">
					<div class="col-sm-10 col-sm-offset-2">
						<input type="hidden" name="action1"/>
						<button type="button" class="btn btn-primary" onclick="doRequest('resolve')">Resolve</button>
						<xsl:text> </xsl:text>
						<button type="button" class="btn btn-primary" onclick="doRequest('response')">Request Response</button>
						<xsl:text> </xsl:text>
						<button type="button" class="btn btn-primary" onclick="doInline()">Request Representation</button>
						<xsl:text> </xsl:text>
						<button type="button" class="btn btn-primary" onclick="doRequest('display')">Request Raw</button>
						<xsl:text> </xsl:text>
						<button type="button" class="btn btn-success" onclick="doRequest('visualize')">
							<span class="fnk fnk-visualizer"> </span> Visualize
						</button>

					</div>
				</div>


			</form>
		</div>

	</xsl:template>

	<xsl:template name="results">
		<div class="row">
			<hr/>
		</div>
		<div id="results">			
			<xsl:apply-templates select="$param/config/resolution" />
			<xsl:apply-templates select="$param/config/response" />
		</div>
	
	
		<div id="repdisplay" style="display: none;">
			<div class="row">
				<div class="col-sm-12">
					<iframe id="repiframe" src="" style="width: 100%; height: 600px;"></iframe>
				</div>
			</div>
		</div>
		


	</xsl:template>

	<xsl:template match="resolution">
	
		<xsl:choose>
			<xsl:when test="toString">
			
				<div class="row">
					<label class="col-sm-2 control-label">Physical Endpoint</label>
					<div class="col-sm-10">
						<div class="pseudo-control">
							<a href="{$explorer}{physicalHash}">
								<span class="ui-icon-ae ui-icon-ae-physical"> </span>
								<xsl:value-of select="toString" />
							</a>					
						</div>
					</div>
				</div>
				
				<div class="row">
					<label class="col-sm-2 control-label">Logical Endpoint</label>
					<div class="col-sm-10">
						<div class="pseudo-control">
							<a href="{$explorer}{logicalHash}">
								<span class="fnk fnk-endpoint"> </span>
								<xsl:value-of select="id" />
							</a>
						</div>
					</div>
				</div>
				
				<div class="row">
					<label class="col-sm-2 control-label">Resolved Scope</label>
					<div class="col-sm-10">
						<div class="pseudo-control">
							<xsl:for-each select="scope/level">
								<div>
									<a href="{$explorer}{hash}">
										<xsl:choose>
											<xsl:when test="position()=last()">
												<span class="ui-icon-ae ui-icon-ae-space"> </span>
											</xsl:when>
											<xsl:otherwise>
												<span class="ui-icon-ae ui-icon-ae-scope"> </span>
											</xsl:otherwise>
										</xsl:choose>
										<xsl:value-of select="space" />
									</a>
								</div>
							</xsl:for-each>
						</div>
					</div>
				</div>
			
			</xsl:when>
			<xsl:when test="exceptionId">
				<div class="col-sm-10 col-sm-offset-2">
					<div class="alert alert-danger">
						<b><xsl:value-of select="exceptionId"/></b><br/>
						<xsl:value-of select="exceptionMsg"/>
					</div>
				</div>
			</xsl:when>
		</xsl:choose>
	
		
		
		<div class="row">
			<label class="col-sm-2 control-label">Resolution</label>
			<div class="col-sm-10">
				<div class="pseudo-control">
					<xsl:for-each select="trace">
						<xsl:call-template name="resolution" />
					</xsl:for-each>
				</div>
			</div>
		</div>
		
	</xsl:template>

	<xsl:template name="space-option">
		<xsl:param name="indent"></xsl:param>
		<option>
			<xsl:attribute name="value">
				<xsl:value-of select="hash" />
			</xsl:attribute>
			<xsl:if test="$param/config/params/space=hash">
				<xsl:attribute name="selected">true</xsl:attribute>
			</xsl:if>
			<xsl:value-of select="$indent" />
			<xsl:if test="public='true'">
				+&#160;
			</xsl:if>
			<xsl:value-of select="id" />
			&#160;&#160;&#160;
			<xsl:value-of select="name" />
		</option>
		<xsl:for-each select="spaces/space">
			<xsl:call-template name="space-option">
				<xsl:with-param name="indent">
					<xsl:value-of select="$indent" />
					&#160;&#160;
				</xsl:with-param>
			</xsl:call-template>
		</xsl:for-each>
	</xsl:template>


	<xsl:template match="response">
		
		<xsl:choose>
			<xsl:when test="repClass">
			
		
				<div class="row">
					<label class="col-sm-2 control-label">Representation Type</label>
					<div class="col-sm-10">
						<div class="pseudo-control">
							<xsl:choose>
							<xsl:when test="repHash">
								<a href="{$explorer}{repHash}">
									<span class="fa fa-picture-o"> </span>
									<xsl:value-of select="repName" />
								</a>
								(
								<xsl:value-of select="repClass" />
								)
							</xsl:when>
							<xsl:otherwise>
								<span class="fa fa-picture-o"> </span>
								<xsl:value-of select="repClass" />
							</xsl:otherwise>
						</xsl:choose>
						</div>
					</div>
				</div>
				
				<div class="row">
					<label class="col-sm-2 control-label">Representation toString()</label>
					<div class="col-sm-10">
						<div >
							<pre>
								<xsl:value-of select="repToString" />
							</pre>
						</div>
					</div>
				</div>
				
				<div class="row">
					<label class="col-sm-2 control-label">Expiry Determinants</label>
					<div class="col-sm-10">
						<div class="pseudo-control">
							<xsl:for-each select="expiry/e">
								<xsl:call-template name="expiry" />
							</xsl:for-each>
						</div>
					</div>
				</div>
				
				<div class="row">
					<label class="col-sm-2 control-label">IsExpired?</label>
					<div class="col-sm-10">
						<div class="pseudo-control">
							<xsl:value-of select="isExpired" />
						</div>
					</div>
				</div>
				
				<div class="row">
					<label class="col-sm-2 control-label">Cost</label>
					<div class="col-sm-10">
						<div class="pseudo-control">
							<xsl:value-of select="cost" />
						</div>
					</div>
				</div>
				
				<div class="row">
					<label class="col-sm-2 control-label">Response Fields</label>
					<div class="col-sm-10">
						<div class="pseudo-control">
							<xsl:choose>
							<xsl:when test="usermeta/value">
								<xsl:for-each select="usermeta/value">
									<xsl:variable name="class">
										<xsl:choose>
											<xsl:when test="position() mod 2 = 0">
												<xsl:text>evenrow</xsl:text>
											</xsl:when>
											<xsl:otherwise>
												<xsl:text>oddrow</xsl:text>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:variable>
									<div class="{$class}">
										<xsl:choose>
											<xsl:when test="@key='ad'">
												[Additional dependencies on locally cached responses]
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="key" />
												=
												<xsl:value-of select="text()" />
											</xsl:otherwise>
										</xsl:choose>
		
									</div>
								</xsl:for-each>
							</xsl:when>
							<xsl:otherwise>
								none
							</xsl:otherwise>
						</xsl:choose>
						</div>
					</div>
				</div>
				
			</xsl:when>
			<xsl:when test="exceptionId">
				<div class="col-sm-10 col-sm-offset-2">
					<div class="alert alert-danger">
						<b><xsl:value-of select="exceptionId"/></b><br/>
						<xsl:value-of select="exceptionMsg"/>
					</div>
				</div>
			</xsl:when>
		</xsl:choose>

	</xsl:template>

	<xsl:template name="expiry">
		<div>

			<xsl:value-of select="@exp" />
			<xsl:value-of select="@msg" />
			<xsl:if test="e">
				<div style="margin-left: 1em;">
					<xsl:for-each select="e">
						<xsl:call-template name="expiry" />
					</xsl:for-each>
				</div>
			</xsl:if>
		</div>
	</xsl:template>


</xsl:stylesheet>
